﻿using Syncfusion.Windows.Forms.Diagram;
using Syncfusion.Windows.Forms.Diagram.Controls;
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace UpdateModelSize
{
    public class CustomController : DiagramController
    {
        Diagram dgm;
        public CustomController(Diagram diagram)
            : base()
        {
            dgm = diagram;
        }

        public CustomController(Syncfusion.Windows.Forms.Diagram.View view)
            : base(view)
        {

        }

        /// <summary>
        /// override the GetBoundingRect method
        /// </summary>
        /// <param name="nodes"></param>
        /// <param name="units"></param>
        /// <returns></returns>
        public override System.Drawing.RectangleF GetBoundingRect(System.Collections.ICollection nodes, MeasureUnits units)
        {
            RectangleF rectTrackerToReturn = RectangleF.Empty;
            Node nodeTemp;

            foreach (object nodeCur in nodes)
            {
                nodeTemp = nodeCur as Node;

                if (nodeTemp != null)
                {
                    RectangleF rectBounding = nodeTemp.GetNodeBounds(true, true);

                    if (rectTrackerToReturn.Size.IsEmpty)
                    {
                        rectTrackerToReturn = rectBounding;
                    }
                    else
                    {
                        rectTrackerToReturn = RectangleF.Union(rectBounding, rectTrackerToReturn);
                    }
                }
            }
            if (dgm.LayoutManager != null)
            {
                rectTrackerToReturn.X -= dgm.LayoutManager.LeftMargin;
                rectTrackerToReturn.Y -= dgm.LayoutManager.TopMargin;
                rectTrackerToReturn.Width += dgm.LayoutManager.LeftMargin;
                rectTrackerToReturn.Height += dgm.LayoutManager.TopMargin;
            }
            rectTrackerToReturn.Width += dgm.Model.RightMargin;
            rectTrackerToReturn.Height += dgm.Model.BottomMargin;

            return rectTrackerToReturn;
        }
    }
}

//using Syncfusion.Windows.Forms.Diagram;
//using System;
//using System.Collections.Generic;
//using System.Drawing;
//using System.Linq;
//using System.Text;
//using System.Threading.Tasks;

//namespace UpdateModelSize
//{
//    public class CustomController : DiagramController
//    {
//        /// <summary>
//        /// updating the origin offset
//        /// </summary>
//        private SizeF m_originoffset= SizeF.Empty;

//        public CustomController()
//            : base()
//        {

//        }

//        public CustomController(Syncfusion.Windows.Forms.Diagram.View view)
//            : base(view)
//        {
            
//        }

//        /// <summary>
//        /// override the GetBoundingRect method
//        /// </summary>=
//        /// <param name="nodes"></param>
//        /// <param name="units"></param>
//        /// <returns></returns>
//        public override System.Drawing.RectangleF GetBoundingRect(System.Collections.ICollection nodes, MeasureUnits units)
//        {
//            Model model = this.Model;
//            // get model node collection
//            NodeCollection modelNodes = Model.Nodes;

//            // get content bounds
//            RectangleF rcNodeBounds;
//            RectangleF returnBounds = new RectangleF(m_originoffset.ToPointF(), SizeF.Empty);

//            foreach (Node node in modelNodes)
//            {
//                rcNodeBounds = ((IUnitIndependent)node).GetBoundingRectangle(model.MeasurementUnits, false);
//                returnBounds = RectangleF.Union(returnBounds, rcNodeBounds);
//            }
//            m_originoffset.Width -= returnBounds.X;
//            m_originoffset.Height -= returnBounds.Y;
//            returnBounds.Width = Math.Max(model.MinimumSize.Width + m_originoffset.Width, returnBounds.Width);
//            returnBounds.Height = Math.Max(model.MinimumSize.Height + m_originoffset.Height, returnBounds.Height);
//            return returnBounds;
//        }
//    }
//}
